function TauntWatchFrame_OnLoad()

if TWConfig == nil then
	TWConfig = {
		["Reports"] = 'ON'
	}
end

SlashCmdList["TWHANDLER"] = twhandler;
	SLASH_TWHANDLER1 = "/tw"

TauntWatchFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[TauntWatch]|r v" .. GetAddOnMetadata("Alices-TauntWatch", "Version") .. " loaded. Use |cFF00FFFF/tw rep|r to disable all reports.");
TauntWatchFrame:Hide();

end

function TauntWatchFrame_OnEvent(event, ...)

if TWConfig.Reports == "OFF" then
	return
else

	local timestamp, ttype, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellid, spellname, spellschool, b_or_d = select(1, ...);
	local TYP = tonumber(sourceGUID:sub(5,5), 16);
	local maskedTYP = TYP % 8;
	local knownTypes = {[0]="player", [3]="NPC", [4]="pet", [5]="vehicle"};
	local lang = GetDefaultLanguage("player")

	local inParty = GetNumPartyMembers()>=1
	local inRaid = GetNumRaidMembers()>=1
	local myName = UnitName("player")

	if (ttype == "SPELL_AURA_APPLIED") then

		if (spellid == 355) or (spellid == 57755) or (spellid == 34477) or (spellid == 31789) or (spellid == 48263) or (spellid == 62124) or (spellid == 25780) or (spellid == 57934) or (spellid == 8056) or (spellid == 49576) or (spellid == 56222) or (spellid == 6795) or (spellid == 20736) then
			if sourceName ~= myName and UnitInRaid(sourceName) and (inRaid) then
					if (destName) then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "RAID",lang)
					else
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "RAID",lang)
					end
			elseif sourceName ~= myName and UnitInParty(sourceName) and (inParty) then
					if (destName) then
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. " on " .. destName .. ".", "PARTY",lang)
					else
						SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "PARTY",lang)
					end
			end
		elseif (spellid == 71) then
			if sourceName ~= myName and UnitInRaid(sourceName) and (inRaid) then
				SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "RAID",lang)
			elseif sourceName ~= myName and UnitInParty(sourceName) and (inParty) then
				SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "PARTY",lang)
			end		
		end
	elseif (ttype == "SPELL_CAST_SUCCESS") then
		if (spellid == 5209) or (spellid == 1161) then
			if sourceName ~= myName and UnitInRaid(sourceName) and (inRaid) then
				SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "RAID",lang)
			elseif sourceName ~= myName and UnitInParty(sourceName) and (inParty) then
				SendChatMessage("<TauntWatch> " .. sourceName .. " used " .. GetSpellLink(spellid) .. ".", "PARTY",lang)
			end
		end
	end
end

end

function twhandler(msg, editbox)

if msg == "rep" then

	if TWConfig.Reports == "ON" then
		TWConfig.Reports = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[TauntWatch]|r Reports have been turned |cFFFF0000off|r.")
	elseif TWConfig.Reports == "OFF" then
		TWConfig.Reports = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[TauntWatch]|r Reports have been turned |cFF00FF00on|r.")
	end

else
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[TauntWatch]|r Please use one of the following arguments: rep")
end

end